program cpuinfo;
{Written by Hunter Beanland. http://www.geocities.com/SiliconValley/Lab/1672/
 Please do not delete these lines!}

{***************************************************************
*  Written by  Hunter Beanland   Nov 1997
*  Portions by Intel Corp, Borland Intl
****************************************************************}
const
 MAXCLOCKS=150;		{ Maximum number of cycles per BSF instruction}
                        {ACCURACY AFFECTING CONSTANTS===}
 ITERATIONS=1500;	{ Number of times to repeat BSF
			{   instruction in samplings.
			{   Initially set to 4000. --1500
			{   NOTE-- Set this value
			{   identically in timeproc.asm}
 SAMPLING_DELAY=500;	{ Number of ticks to allow to
			{   to elapse during sampling.
			{   Initially set to 60.}
 TOLERANCE=2;           { Number of MHz to allow
			{   samplings to deviate from
			{   average of samplings.
			{   Initially set to 2.}
 MAX_TRIES=20;	        { Maximum number of samplings
			{   to allow before giving up
			{   and returning current
			{   average. Initially set to
			{   20.}
 SAMPLINGS=10;	        { Number of BSF sequence
			{   samplings to make.
			{   Initially set to 10.
 	                { Number of MHz above normal-
			{   ised value to normalise
			{   down to the current normalised speed.}
{ Number of cycles needed to execute a single BSF
{   instruction. Note that processors below i386(tm)
{   are not supported.}

processor_cycles:array[0..20] of integer = (
	00,  00,  00, 115, 48, 43,
	38,  38,  38, 38,  38, 38,
	38,  38,  38, 38,  38, 38,
	38,  38,  38);

{***************************************************************}
label jump;
var i:integer;
    u0,u1,v0,v1,t0,t1:word;
    manual,tries:integer;
    current,lowest,ticks,cycles,stamp0,stamp1:longint;
    freq,freq2,freq3,total,aver:longint;
    processor:word;
    ch:char;
    cputype:word;
    stepping,model:byte;
    cpuid_support:boolean;
    vendor_id:string[12];

{TIME_PROCESSOR_BSF() -- Perform nITERATIONS of the BSF instructions.
 Returns: # of ticks instruction sequence ran. }
{$L timeproc.obj}
function _Time_Processor_bsf:word; far; external;

{ GRABTIME -- Read Time from Counter.
 Returns: Value in PC Chipset Timer. }
function _GrabTime:word; far; external;

procedure CPUIdent;
begin
  cputype:=0;
  cpuid_support:=false;
  vendor_id:='            ';
  if (Test8086 = 2) then         { RTL check stops at 2 = 386}
  asm
             inc    Test8086     { 3 = 386, for consistency }
    { Do we have a 386 or a 486? }
    { Does pushf/popf preserve the Alignment Check bit? (386=no, 486=yes) }
             mov    bx, sp       { save current stack pointer }
             and    sp, not 3    { align stack to avoid AC fault }
    db $66;  pushf
    db $66;  pop    ax
    db $66;  mov    cx, ax
    db $66, $35; dd $40000       { xor AC bit in EFLAGS }
    db $66;  push   ax
    db $66;  popf
    db $66;  pushf
    db $66;  pop    ax
    db $66;  xor    ax, cx       { Is AC bit toggled? }
             je @@1              { if not, we have a 386 }
             and    sp, not 3    { align stack to avoid AC fault }
    db $66;  push   cx
    db $66;  popf                { restore original AC bit }
             mov    sp, bx       { restore original stack pointer }
             mov  Test8086, 4    { we know we have at least a 486 }

    { Do we have a 486 or a Pentium? }
    { Does pushf/popf preserve the CPUID bit? (486=no, P5=yes) }
    db $66;  mov    ax, cx       { get original EFLAGS}
    db $66, $35; dd $200000      { XOR id bit in flags}
    db $66;  push   ax
    db $66;  popf
    db $66;  pushf
    db $66;  pop    ax
    db $66;  xor    ax, cx      { Is CPUID bit toggled? }
             je @@1             { if not, we have a 486 }
    db $66;  xor    ax, ax
    db $f,$a2                   { CPUID, AX = 0 (get CPUID) }
    db $66;  cmp    ax, 1
             jl @@1             { if < 1, then exit }
    db $66;  xor    ax, ax
    db $66;  inc    ax

    db $f,$a2                   { CPUID, AX = 1 (get CPU info)   }
    mov 	stepping, al
    and	stepping, 0fh
    and 	al, $f0
    shr	al, 4
    mov 	model, al
    and	ax, 0f00h
    shr     ax, 8		   { Isolate family}
    and	ax, 0fh
    mov     cputype, ax	           { Set cpu_type with family}

    db $66;  xor     ax, ax        { Set up for CPUID instruction}
    db $f,$a2                      { Get and save vendor ID}
    db $66;  mov     word ptr vendor_id[+1], bx
    db $66;  mov     word ptr vendor_id[+5], dx
    db $66;  mov     word ptr vendor_id[+9], cx
    mov cpuid_support, 1           {set to true}
   @@1:
  end;
end;

begin
  current:= 0;
  lowest:= 2147483647;
  manual:=0;
  freq:=0;
  tries:=0;

  cpuident;            {run external ident procedure}
  processor:=cputype;
  cycles:= longint(iterations) * longint(processor_cycles[processor]);

    if (processor >= 3)  then begin
	if ( processor >= 6 ) then begin
          repeat
                tries:=tries+1;	{ Increment number of times
					{   sampled on this call to
					{   cpuspeed}

		freq3:= freq2;	{ Shift frequencies back to}
		freq2:= freq;	{   make room for new frequency
					{   measurement}
		t0:=_GrabTime;	{ Get Start Time. This code
					{   directly peeks the Counter/
					{   Timer. This tends to cause
					{   inaccuracies on MS-Windows* NT}
		asm	db $f, $31;	{ Read Time Stamp}
	       		MOV CL, 16
			MOV u0, AX
			db $66;	SHR	AX,CL
			MOV u1, AX
    	        end;
	        t1:=t0;
  		while ( t1 - t0 < SAMPLING_DELAY ) do
   			 	{ Loop until 500 ticks have passed
    			  	{   since last GrabTime read.
    			  	{   This allows for elapsed time
    			  	{   for sampling}
	    			t1:= _GrabTime;	{ Get End Time}
   	    asm db $f, $31;		{ Read Time Stamp}
		MOV CL, 16
		MOV v0, AX
		db $66;	SHR	AX,CL
		MOV v1, AX
            end;
            stamp0:=  u1*65536 + u0;
   	    stamp1:=  v1*65536 + v0;
				{ Move two 16-bit values into one
				{   32-bit value for the time stamp
				{   read at both the beginning and
				{   end of the test}
      	    cycles:= stamp1 - stamp0;
            ticks:=t1 - t0;
   	    ticks:= ticks * 100000;
        		{ Convert ticks to hundred
			{   thousandths of a tick}
            ticks:=round(ticks/119318);
			{ Convert hundred thousandths of
			{   ticks to microseconds (us)}
	    freq:=round(cycles/ticks);{ Cycles / us  = MHz}
  	    total:= ( freq + freq2 + freq3 );
				{ Total last three frequency
				{   calculations}
                  aver:=round(total/3);
                until ((tries=max_tries) or ((abs(freq-aver)<tolerance)
                 or (abs(freq2-aver)<tolerance) or (abs(freq3-aver)<tolerance)));

		freq:=aver;	{ Average last three calculations}
        end {cpu=>6}
        else begin {cpu=386-586}
				{ If processor does not support ring 0
				{   time stamp reading, but is at least
				{   a 386 or above, utilize method of
				{   timing a loop of BSF instructions
				{   which take a known number of cycles
				{   to run on i386(tm), i486(tm), and
				{   Pentium(R) processors.}
		for i:= 1 to SAMPLINGS do begin
				{ Sample Ten times. Can be increased or
				{   decreased depending on accuracy vs.
				{   time requirements}
  		  current:= _Time_Processor_bsf;
		  if ( current < lowest ) then	{ Take lowest elapsed}
 		   lowest:= current;	{   time to account}
					{   for some samplings
					{   being interrupted
					{   by other operations}
		end; {samplings loop}
		ticks:= lowest;
    	        ticks:= ticks * 100000; { Convert ticks to hundred
      		 		    {   thousandths of a tick}
                ticks:=round(ticks/119318);	{ Convert hundred
					{   thousandths of ticks to
					{   microseconds (us) }
       					{ Round up if necessary}
	        freq:=round(cycles/ticks);	{ Cycles / us  = MHz}
        end;  {cpu=386-586}
    end;      {>=386 !clone}

  if cputype=0 then cputype:=test8086;
  write('CPU: ');
  case cputype of
    5: write('Pentium');
    6: if model=1 then write('Pentium Pro')
       else if model=2 then write('Pentium Pro/II') {I'm not sure which}
       else write('Pentium II');
    else writeln(cputype,'86');
  end;
  if freq>0 then write(' ',freq,' MHz');
  if cpuid_support then writeln(' (Model ',model,', Stepping ',stepping,', "',vendor_id,'")');
end.
